package com.kingdee.eas.custom.dormitorysystem.application;

import com.kingdee.bos.framework.ejb.EJBRemoteException;
import com.kingdee.bos.util.BOSObjectType;
import java.rmi.RemoteException;
import com.kingdee.bos.framework.AbstractBizCtrl;
import com.kingdee.bos.orm.template.ORMObject;

import com.kingdee.bos.util.*;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.bos.Context;
import com.kingdee.eas.hr.base.HRBillBaseEntry;
import com.kingdee.eas.custom.dormitorysystem.application.app.*;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.hr.base.IHRBillBaseEntry;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import java.lang.String;
import com.kingdee.bos.framework.*;

public class CheckoutApplicationEntry extends HRBillBaseEntry implements ICheckoutApplicationEntry
{
    public CheckoutApplicationEntry()
    {
        super();
        registerInterface(ICheckoutApplicationEntry.class, this);
    }
    public CheckoutApplicationEntry(Context ctx)
    {
        super(ctx);
        registerInterface(ICheckoutApplicationEntry.class, this);
    }
    public BOSObjectType getType()
    {
        return new BOSObjectType("74F1AE25");
    }
    private CheckoutApplicationEntryController getController() throws BOSException
    {
        return (CheckoutApplicationEntryController)getBizController();
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@return
     */
    public CheckoutApplicationEntryInfo getCheckoutApplicationEntryInfo(IObjectPK pk) throws BOSException, EASBizException
    {
        try {
            return getController().getCheckoutApplicationEntryInfo(getContext(), pk);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param pk ȡֵ
     *@param selector ȡֵ
     *@return
     */
    public CheckoutApplicationEntryInfo getCheckoutApplicationEntryInfo(IObjectPK pk, SelectorItemCollection selector) throws BOSException, EASBizException
    {
        try {
            return getController().getCheckoutApplicationEntryInfo(getContext(), pk, selector);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡֵ-System defined method
     *@param oql ȡֵ
     *@return
     */
    public CheckoutApplicationEntryInfo getCheckoutApplicationEntryInfo(String oql) throws BOSException, EASBizException
    {
        try {
            return getController().getCheckoutApplicationEntryInfo(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@return
     */
    public CheckoutApplicationEntryCollection getCheckoutApplicationEntryCollection() throws BOSException
    {
        try {
            return getController().getCheckoutApplicationEntryCollection(getContext());
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param view ȡ
     *@return
     */
    public CheckoutApplicationEntryCollection getCheckoutApplicationEntryCollection(EntityViewInfo view) throws BOSException
    {
        try {
            return getController().getCheckoutApplicationEntryCollection(getContext(), view);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ȡ-System defined method
     *@param oql ȡ
     *@return
     */
    public CheckoutApplicationEntryCollection getCheckoutApplicationEntryCollection(String oql) throws BOSException
    {
        try {
            return getController().getCheckoutApplicationEntryCollection(getContext(), oql);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
}