/**
 * output package name
 */
package com.kingdee.eas.custom.dormitorysystem.occupants.client;

import org.apache.log4j.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.border.*;
import javax.swing.BorderFactory;
import javax.swing.event.*;
import javax.swing.KeyStroke;

import com.kingdee.bos.ctrl.swing.*;
import com.kingdee.bos.ctrl.kdf.table.*;
import com.kingdee.bos.ctrl.kdf.data.event.*;
import com.kingdee.bos.dao.*;
import com.kingdee.bos.dao.query.*;
import com.kingdee.bos.metadata.*;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.ui.face.*;
import com.kingdee.bos.ui.util.ResourceBundleHelper;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.service.ServiceContext;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.enums.EnumUtils;
import com.kingdee.bos.ui.face.UIRuleUtil;
import com.kingdee.bos.ctrl.swing.event.*;
import com.kingdee.bos.ctrl.kdf.table.event.*;
import com.kingdee.bos.ctrl.extendcontrols.*;
import com.kingdee.bos.ctrl.kdf.util.render.*;
import com.kingdee.bos.ui.face.IItemAction;
import com.kingdee.eas.framework.batchHandler.RequestContext;
import com.kingdee.bos.ui.util.IUIActionPostman;
import com.kingdee.bos.appframework.client.servicebinding.ActionProxyFactory;
import com.kingdee.bos.appframework.uistatemanage.ActionStateConst;
import com.kingdee.bos.appframework.validator.ValidateHelper;
import com.kingdee.bos.appframework.uip.UINavigator;


/**
 * output class name
 */
public abstract class AbstractOccupantsEditUI extends com.kingdee.eas.framework.client.EditUI
{
    private static final Logger logger = CoreUIObject.getLogger(AbstractOccupantsEditUI.class);
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer1;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer2;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer3;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer kDLabelContainer4;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contperson;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contpersonPosition;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contPersonDormitoryType;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCheckInDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contCheckOutDate;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contDormitory;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contRemarks;
    protected com.kingdee.bos.ctrl.swing.KDLabelContainer contstate;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtNumber;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox txtName;
    protected com.kingdee.bos.ctrl.swing.KDTextField txtSimpleName;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox txtDescription;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtperson;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtpersonPosition;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtPersonDormitoryType;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkCheckInDate;
    protected com.kingdee.bos.ctrl.swing.KDDatePicker pkCheckOutDate;
    protected com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox prmtDormitory;
    protected com.kingdee.bos.ctrl.swing.KDScrollPane scrollPaneRemarks;
    protected com.kingdee.bos.ctrl.swing.KDTextArea txtRemarks;
    protected com.kingdee.bos.ctrl.swing.KDComboBox state;
    protected com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo editData = null;
    /**
     * output class constructor
     */
    public AbstractOccupantsEditUI() throws Exception
    {
        super();
        this.defaultObjectName = "editData";
        jbInit();
        
        initUIP();
    }

    /**
     * output jbInit method
     */
    private void jbInit() throws Exception
    {
        this.resHelper = new ResourceBundleHelper(AbstractOccupantsEditUI.class.getName());
        this.setUITitle(resHelper.getString("this.title"));
        this.kDLabelContainer1 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kDLabelContainer2 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kDLabelContainer3 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.kDLabelContainer4 = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contperson = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contpersonPosition = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contPersonDormitoryType = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCheckInDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contCheckOutDate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contDormitory = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contRemarks = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.contstate = new com.kingdee.bos.ctrl.swing.KDLabelContainer();
        this.txtNumber = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtName = new com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox();
        this.txtSimpleName = new com.kingdee.bos.ctrl.swing.KDTextField();
        this.txtDescription = new com.kingdee.bos.ctrl.extendcontrols.KDBizMultiLangBox();
        this.prmtperson = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtpersonPosition = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.prmtPersonDormitoryType = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.pkCheckInDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.pkCheckOutDate = new com.kingdee.bos.ctrl.swing.KDDatePicker();
        this.prmtDormitory = new com.kingdee.bos.ctrl.extendcontrols.KDBizPromptBox();
        this.scrollPaneRemarks = new com.kingdee.bos.ctrl.swing.KDScrollPane();
        this.txtRemarks = new com.kingdee.bos.ctrl.swing.KDTextArea();
        this.state = new com.kingdee.bos.ctrl.swing.KDComboBox();
        this.kDLabelContainer1.setName("kDLabelContainer1");
        this.kDLabelContainer2.setName("kDLabelContainer2");
        this.kDLabelContainer3.setName("kDLabelContainer3");
        this.kDLabelContainer4.setName("kDLabelContainer4");
        this.contperson.setName("contperson");
        this.contpersonPosition.setName("contpersonPosition");
        this.contPersonDormitoryType.setName("contPersonDormitoryType");
        this.contCheckInDate.setName("contCheckInDate");
        this.contCheckOutDate.setName("contCheckOutDate");
        this.contDormitory.setName("contDormitory");
        this.contRemarks.setName("contRemarks");
        this.contstate.setName("contstate");
        this.txtNumber.setName("txtNumber");
        this.txtName.setName("txtName");
        this.txtSimpleName.setName("txtSimpleName");
        this.txtDescription.setName("txtDescription");
        this.prmtperson.setName("prmtperson");
        this.prmtpersonPosition.setName("prmtpersonPosition");
        this.prmtPersonDormitoryType.setName("prmtPersonDormitoryType");
        this.pkCheckInDate.setName("pkCheckInDate");
        this.pkCheckOutDate.setName("pkCheckOutDate");
        this.prmtDormitory.setName("prmtDormitory");
        this.scrollPaneRemarks.setName("scrollPaneRemarks");
        this.txtRemarks.setName("txtRemarks");
        this.state.setName("state");
        // CoreUI		
        this.btnPrint.setVisible(false);		
        this.btnPrintPreview.setVisible(false);		
        this.menuItemPrint.setVisible(false);		
        this.menuItemPrintPreview.setVisible(false);
        // kDLabelContainer1		
        this.kDLabelContainer1.setBoundLabelText(resHelper.getString("kDLabelContainer1.boundLabelText"));		
        this.kDLabelContainer1.setBoundLabelLength(100);		
        this.kDLabelContainer1.setBoundLabelUnderline(true);
        // kDLabelContainer2		
        this.kDLabelContainer2.setBoundLabelText(resHelper.getString("kDLabelContainer2.boundLabelText"));		
        this.kDLabelContainer2.setBoundLabelLength(100);		
        this.kDLabelContainer2.setBoundLabelUnderline(true);
        // kDLabelContainer3		
        this.kDLabelContainer3.setBoundLabelText(resHelper.getString("kDLabelContainer3.boundLabelText"));		
        this.kDLabelContainer3.setBoundLabelLength(100);		
        this.kDLabelContainer3.setBoundLabelUnderline(true);
        // kDLabelContainer4		
        this.kDLabelContainer4.setBoundLabelText(resHelper.getString("kDLabelContainer4.boundLabelText"));		
        this.kDLabelContainer4.setBoundLabelLength(100);		
        this.kDLabelContainer4.setBoundLabelUnderline(true);		
        this.kDLabelContainer4.setBoundLabelAlignment(7);		
        this.kDLabelContainer4.setVisible(true);
        // contperson		
        this.contperson.setBoundLabelText(resHelper.getString("contperson.boundLabelText"));		
        this.contperson.setBoundLabelLength(100);		
        this.contperson.setBoundLabelUnderline(true);		
        this.contperson.setVisible(true);
        // contpersonPosition		
        this.contpersonPosition.setBoundLabelText(resHelper.getString("contpersonPosition.boundLabelText"));		
        this.contpersonPosition.setBoundLabelLength(100);		
        this.contpersonPosition.setBoundLabelUnderline(true);		
        this.contpersonPosition.setVisible(true);
        // contPersonDormitoryType		
        this.contPersonDormitoryType.setBoundLabelText(resHelper.getString("contPersonDormitoryType.boundLabelText"));		
        this.contPersonDormitoryType.setBoundLabelLength(100);		
        this.contPersonDormitoryType.setBoundLabelUnderline(true);		
        this.contPersonDormitoryType.setVisible(true);
        // contCheckInDate		
        this.contCheckInDate.setBoundLabelText(resHelper.getString("contCheckInDate.boundLabelText"));		
        this.contCheckInDate.setBoundLabelLength(100);		
        this.contCheckInDate.setBoundLabelUnderline(true);		
        this.contCheckInDate.setVisible(true);
        // contCheckOutDate		
        this.contCheckOutDate.setBoundLabelText(resHelper.getString("contCheckOutDate.boundLabelText"));		
        this.contCheckOutDate.setBoundLabelLength(100);		
        this.contCheckOutDate.setBoundLabelUnderline(true);		
        this.contCheckOutDate.setVisible(true);
        // contDormitory		
        this.contDormitory.setBoundLabelText(resHelper.getString("contDormitory.boundLabelText"));		
        this.contDormitory.setBoundLabelLength(100);		
        this.contDormitory.setBoundLabelUnderline(true);		
        this.contDormitory.setVisible(true);
        // contRemarks		
        this.contRemarks.setBoundLabelText(resHelper.getString("contRemarks.boundLabelText"));		
        this.contRemarks.setBoundLabelLength(100);		
        this.contRemarks.setBoundLabelUnderline(true);		
        this.contRemarks.setVisible(true);
        // contstate		
        this.contstate.setBoundLabelText(resHelper.getString("contstate.boundLabelText"));		
        this.contstate.setBoundLabelLength(100);		
        this.contstate.setBoundLabelUnderline(true);		
        this.contstate.setVisible(true);
        // txtNumber		
        this.txtNumber.setMaxLength(80);
        // txtName
        // txtSimpleName		
        this.txtSimpleName.setMaxLength(80);
        // txtDescription
        // prmtperson		
        this.prmtperson.setQueryInfo("com.kingdee.eas.basedata.person.app.PersonFilterQuery");		
        this.prmtperson.setVisible(true);		
        this.prmtperson.setEditable(true);		
        this.prmtperson.setDisplayFormat("$name$");		
        this.prmtperson.setEditFormat("$number$");		
        this.prmtperson.setCommitFormat("$number$");		
        this.prmtperson.setRequired(false);
        // prmtpersonPosition		
        this.prmtpersonPosition.setVisible(true);		
        this.prmtpersonPosition.setEditable(true);		
        this.prmtpersonPosition.setDisplayFormat("$joinDate$");		
        this.prmtpersonPosition.setEditFormat("$number$");		
        this.prmtpersonPosition.setCommitFormat("$number$");		
        this.prmtpersonPosition.setRequired(false);
        // prmtPersonDormitoryType		
        this.prmtPersonDormitoryType.setQueryInfo("com.kingdee.eas.custom.dormitorysystem.otherbasicdata.app.PersonDormitoryTypeQuery");		
        this.prmtPersonDormitoryType.setVisible(true);		
        this.prmtPersonDormitoryType.setEditable(true);		
        this.prmtPersonDormitoryType.setDisplayFormat("$name$");		
        this.prmtPersonDormitoryType.setEditFormat("$number$");		
        this.prmtPersonDormitoryType.setCommitFormat("$number$");		
        this.prmtPersonDormitoryType.setRequired(false);
        		prmtPersonDormitoryType.addSelectorListener(new SelectorListener() {
			com.kingdee.eas.custom.dormitorysystem.otherbasicdata.client.PersonDormitoryTypeListUI prmtPersonDormitoryType_F7ListUI = null;
			public void willShow(SelectorEvent e) {
				if (prmtPersonDormitoryType_F7ListUI == null) {
					try {
						prmtPersonDormitoryType_F7ListUI = new com.kingdee.eas.custom.dormitorysystem.otherbasicdata.client.PersonDormitoryTypeListUI();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
					HashMap ctx = new HashMap();
					ctx.put("bizUIOwner",javax.swing.SwingUtilities.getWindowAncestor(prmtPersonDormitoryType_F7ListUI));
					prmtPersonDormitoryType_F7ListUI.setF7Use(true,ctx);
					prmtPersonDormitoryType.setSelector(prmtPersonDormitoryType_F7ListUI);
				}
			}
		});
					
        // pkCheckInDate		
        this.pkCheckInDate.setVisible(true);		
        this.pkCheckInDate.setRequired(false);
        // pkCheckOutDate		
        this.pkCheckOutDate.setVisible(true);		
        this.pkCheckOutDate.setRequired(false);
        // prmtDormitory		
        this.prmtDormitory.setQueryInfo("com.kingdee.eas.custom.dormitorysystem.dormitory.app.DormitoryQuery");		
        this.prmtDormitory.setVisible(true);		
        this.prmtDormitory.setEditable(true);		
        this.prmtDormitory.setDisplayFormat("$RoomNumber$");		
        this.prmtDormitory.setEditFormat("$number$");		
        this.prmtDormitory.setCommitFormat("$number$");		
        this.prmtDormitory.setRequired(false);
        		prmtDormitory.addSelectorListener(new SelectorListener() {
			com.kingdee.eas.custom.dormitorysystem.dormitory.client.DormitoryListUI prmtDormitory_F7ListUI = null;
			public void willShow(SelectorEvent e) {
				if (prmtDormitory_F7ListUI == null) {
					try {
						prmtDormitory_F7ListUI = new com.kingdee.eas.custom.dormitorysystem.dormitory.client.DormitoryListUI();
					} catch (Exception e1) {
						e1.printStackTrace();
					}
					HashMap ctx = new HashMap();
					ctx.put("bizUIOwner",javax.swing.SwingUtilities.getWindowAncestor(prmtDormitory_F7ListUI));
					prmtDormitory_F7ListUI.setF7Use(true,ctx);
					prmtDormitory.setSelector(prmtDormitory_F7ListUI);
				}
			}
		});
					
        // scrollPaneRemarks
        // txtRemarks		
        this.txtRemarks.setVisible(true);		
        this.txtRemarks.setRequired(false);		
        this.txtRemarks.setMaxLength(255);
        // state		
        this.state.setVisible(true);		
        this.state.addItems(EnumUtils.getEnumList("com.kingdee.shr.base.syssetting.BasicItemStateEnum").toArray());		
        this.state.setRequired(false);
        this.setFocusTraversalPolicy(new com.kingdee.bos.ui.UIFocusTraversalPolicy(new java.awt.Component[] {prmtperson,prmtpersonPosition,prmtPersonDormitoryType,pkCheckInDate,pkCheckOutDate,prmtDormitory,txtRemarks,state}));
        this.setFocusCycleRoot(true);
		//Register control's property binding
		registerBindings();
		registerUIState();


    }

	public com.kingdee.bos.ctrl.swing.KDToolBar[] getUIMultiToolBar(){
		java.util.List list = new java.util.ArrayList();
		com.kingdee.bos.ctrl.swing.KDToolBar[] bars = super.getUIMultiToolBar();
		if (bars != null) {
			list.addAll(java.util.Arrays.asList(bars));
		}
		return (com.kingdee.bos.ctrl.swing.KDToolBar[])list.toArray(new com.kingdee.bos.ctrl.swing.KDToolBar[list.size()]);
	}




    /**
     * output initUIContentLayout method
     */
    public void initUIContentLayout()
    {
        this.setBounds(new Rectangle(0, 0, 1013, 629));
        this.setLayout(null);
        kDLabelContainer1.setBounds(new Rectangle(102, 44, 270, 19));
        this.add(kDLabelContainer1, null);
        kDLabelContainer2.setBounds(new Rectangle(102, 81, 270, 19));
        this.add(kDLabelContainer2, null);
        kDLabelContainer3.setBounds(new Rectangle(102, 118, 270, 19));
        this.add(kDLabelContainer3, null);
        kDLabelContainer4.setBounds(new Rectangle(102, 155, 270, 19));
        this.add(kDLabelContainer4, null);
        contperson.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contperson, null);
        contpersonPosition.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contpersonPosition, null);
        contPersonDormitoryType.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contPersonDormitoryType, null);
        contCheckInDate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contCheckInDate, null);
        contCheckOutDate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contCheckOutDate, null);
        contDormitory.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contDormitory, null);
        contRemarks.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contRemarks, null);
        contstate.setBounds(new Rectangle(0, 0, 270, 19));
        this.add(contstate, null);
        //kDLabelContainer1
        kDLabelContainer1.setBoundEditor(txtNumber);
        //kDLabelContainer2
        kDLabelContainer2.setBoundEditor(txtName);
        //kDLabelContainer3
        kDLabelContainer3.setBoundEditor(txtSimpleName);
        //kDLabelContainer4
        kDLabelContainer4.setBoundEditor(txtDescription);
        //contperson
        contperson.setBoundEditor(prmtperson);
        //contpersonPosition
        contpersonPosition.setBoundEditor(prmtpersonPosition);
        //contPersonDormitoryType
        contPersonDormitoryType.setBoundEditor(prmtPersonDormitoryType);
        //contCheckInDate
        contCheckInDate.setBoundEditor(pkCheckInDate);
        //contCheckOutDate
        contCheckOutDate.setBoundEditor(pkCheckOutDate);
        //contDormitory
        contDormitory.setBoundEditor(prmtDormitory);
        //contRemarks
        contRemarks.setBoundEditor(scrollPaneRemarks);
        //scrollPaneRemarks
        scrollPaneRemarks.getViewport().add(txtRemarks, null);
        //contstate
        contstate.setBoundEditor(state);

    }


    /**
     * output initUIMenuBarLayout method
     */
    public void initUIMenuBarLayout()
    {
        this.menuBar.add(menuFile);
        this.menuBar.add(menuEdit);
        this.menuBar.add(MenuService);
        this.menuBar.add(menuView);
        this.menuBar.add(menuBiz);
        this.menuBar.add(menuTool);
        this.menuBar.add(menuHelp);
        //menuFile
        menuFile.add(menuItemAddNew);
        menuFile.add(kDSeparator1);
        menuFile.add(menuItemCloudFeed);
        menuFile.add(menuItemSave);
        menuFile.add(menuItemCloudScreen);
        menuFile.add(menuItemSubmit);
        menuFile.add(menuItemCloudShare);
        menuFile.add(menuSubmitOption);
        menuFile.add(kdSeparatorFWFile1);
        menuFile.add(rMenuItemSubmit);
        menuFile.add(rMenuItemSubmitAndAddNew);
        menuFile.add(rMenuItemSubmitAndPrint);
        menuFile.add(separatorFile1);
        menuFile.add(MenuItemAttachment);
        menuFile.add(kDSeparator2);
        menuFile.add(menuItemPageSetup);
        menuFile.add(menuItemPrint);
        menuFile.add(menuItemPrintPreview);
        menuFile.add(kDSeparator3);
        menuFile.add(menuItemExitCurrent);
        //menuSubmitOption
        menuSubmitOption.add(chkMenuItemSubmitAndAddNew);
        menuSubmitOption.add(chkMenuItemSubmitAndPrint);
        //menuEdit
        menuEdit.add(menuItemCopy);
        menuEdit.add(menuItemEdit);
        menuEdit.add(menuItemRemove);
        menuEdit.add(kDSeparator4);
        menuEdit.add(menuItemReset);
        //MenuService
        MenuService.add(MenuItemKnowStore);
        MenuService.add(MenuItemAnwser);
        MenuService.add(SepratorService);
        MenuService.add(MenuItemRemoteAssist);
        //menuView
        menuView.add(menuItemFirst);
        menuView.add(menuItemPre);
        menuView.add(menuItemNext);
        menuView.add(menuItemLast);
        //menuBiz
        menuBiz.add(menuItemCancelCancel);
        menuBiz.add(menuItemCancel);
        //menuTool
        menuTool.add(menuItemMsgFormat);
        menuTool.add(menuItemSendMessage);
        menuTool.add(menuItemCalculator);
        menuTool.add(menuItemToolBarCustom);
        //menuHelp
        menuHelp.add(menuItemHelp);
        menuHelp.add(kDSeparator12);
        menuHelp.add(menuItemRegPro);
        menuHelp.add(menuItemPersonalSite);
        menuHelp.add(helpseparatorDiv);
        menuHelp.add(menuitemProductval);
        menuHelp.add(kDSeparatorProduct);
        menuHelp.add(menuItemAbout);

    }

    /**
     * output initUIToolBarLayout method
     */
    public void initUIToolBarLayout()
    {
        this.toolBar.add(btnAddNew);
        this.toolBar.add(btnCloud);
        this.toolBar.add(btnEdit);
        this.toolBar.add(btnXunTong);
        this.toolBar.add(btnReset);
        this.toolBar.add(kDSeparatorCloud);
        this.toolBar.add(btnSave);
        this.toolBar.add(btnSubmit);
        this.toolBar.add(btnCopy);
        this.toolBar.add(btnRemove);
        this.toolBar.add(btnAttachment);
        this.toolBar.add(separatorFW1);
        this.toolBar.add(btnPageSetup);
        this.toolBar.add(btnPrint);
        this.toolBar.add(btnPrintPreview);
        this.toolBar.add(separatorFW2);
        this.toolBar.add(btnFirst);
        this.toolBar.add(btnPre);
        this.toolBar.add(btnNext);
        this.toolBar.add(btnLast);
        this.toolBar.add(separatorFW3);
        this.toolBar.add(btnCancelCancel);
        this.toolBar.add(btnCancel);


    }

	//Regiester control's property binding.
	private void registerBindings(){
		dataBinder.registerBinding("number", String.class, this.txtNumber, "text");
		dataBinder.registerBinding("name", String.class, this.txtName, "_multiLangItem");
		dataBinder.registerBinding("simpleName", String.class, this.txtSimpleName, "text");
		dataBinder.registerBinding("description", String.class, this.txtDescription, "_multiLangItem");
		dataBinder.registerBinding("person", com.kingdee.eas.basedata.person.PersonInfo.class, this.prmtperson, "data");
		dataBinder.registerBinding("personPosition", com.kingdee.eas.hr.emp.PersonPositionInfo.class, this.prmtpersonPosition, "data");
		dataBinder.registerBinding("PersonDormitoryType", com.kingdee.eas.custom.dormitorysystem.otherbasicdata.PersonDormitoryTypeInfo.class, this.prmtPersonDormitoryType, "data");
		dataBinder.registerBinding("CheckInDate", java.util.Date.class, this.pkCheckInDate, "value");
		dataBinder.registerBinding("CheckOutDate", java.util.Date.class, this.pkCheckOutDate, "value");
		dataBinder.registerBinding("Dormitory", com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo.class, this.prmtDormitory, "data");
		dataBinder.registerBinding("Remarks", String.class, this.txtRemarks, "text");
		dataBinder.registerBinding("state", com.kingdee.shr.base.syssetting.BasicItemStateEnum.class, this.state, "selectedItem");		
	}
	//Regiester UI State
	private void registerUIState(){
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtName, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtDescription, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtNumber, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_ADDNEW, this.txtSimpleName, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtName, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtDescription, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtNumber, ActionStateConst.ENABLED);
	        getActionManager().registerUIState(STATUS_EDIT, this.txtSimpleName, ActionStateConst.ENABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtName, ActionStateConst.DISABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtDescription, ActionStateConst.DISABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtNumber, ActionStateConst.DISABLED);					 	        		
	        getActionManager().registerUIState(STATUS_VIEW, this.txtSimpleName, ActionStateConst.DISABLED);		
	}
	public String getUIHandlerClassName() {
	    return "com.kingdee.eas.custom.dormitorysystem.occupants.app.OccupantsEditUIHandler";
	}
	public IUIActionPostman prepareInit() {
		IUIActionPostman clientHanlder = super.prepareInit();
		if (clientHanlder != null) {
			RequestContext request = new RequestContext();
    		request.setClassName(getUIHandlerClassName());
			clientHanlder.setRequestContext(request);
		}
		return clientHanlder;
    }
	
	public boolean isPrepareInit() {
    	return false;
    }
    protected void initUIP() {
        super.initUIP();
    }


    /**
     * output onShow method
     */
    public void onShow() throws Exception
    {
        super.onShow();
        this.prmtperson.requestFocusInWindow();
    }

	
	

    /**
     * output setDataObject method
     */
    public void setDataObject(IObjectValue dataObject)
    {
        IObjectValue ov = dataObject;        	    	
        super.setDataObject(ov);
        this.editData = (com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo)ov;
    }
    protected void removeByPK(IObjectPK pk) throws Exception {
    	IObjectValue editData = this.editData;
    	super.removeByPK(pk);
    	recycleNumberByOrg(editData,"NONE",editData.getString("number"));
    }
    
    protected void recycleNumberByOrg(IObjectValue editData,String orgType,String number) {
        if (!StringUtils.isEmpty(number))
        {
            try {
            	String companyID = null;            
            	com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID =com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}				
				if (!StringUtils.isEmpty(companyID) && iCodingRuleManager.isExist(editData, companyID) && iCodingRuleManager.isUseIntermitNumber(editData, companyID)) {
					iCodingRuleManager.recycleNumber(editData,companyID,number);					
				}
            }
            catch (Exception e)
            {
                handUIException(e);
            }
        }
    }
    protected void setAutoNumberByOrg(String orgType) {
    	if (editData == null) return;
		if (editData.getNumber() == null) {
            try {
            	String companyID = null;
				if(!com.kingdee.util.StringUtils.isEmpty(orgType) && !"NONE".equalsIgnoreCase(orgType) && com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType))!=null) {
					companyID = com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit(com.kingdee.eas.basedata.org.OrgType.getEnum(orgType)).getString("id");
				}
				else if (com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit() != null) {
					companyID = ((com.kingdee.eas.basedata.org.OrgUnitInfo)com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentOrgUnit()).getString("id");
            	}
				com.kingdee.eas.base.codingrule.ICodingRuleManager iCodingRuleManager = com.kingdee.eas.base.codingrule.CodingRuleManagerFactory.getRemoteInstance();
		        if (iCodingRuleManager.isExist(editData, companyID)) {
		            if (iCodingRuleManager.isAddView(editData, companyID)) {
		            	editData.setNumber(iCodingRuleManager.getNumber(editData,companyID));
		            }
	                txtNumber.setEnabled(false);
		        }
            }
            catch (Exception e) {
                handUIException(e);
                this.oldData = editData;
                com.kingdee.eas.util.SysUtil.abort();
            } 
        } 
        else {
            if (editData.getNumber().trim().length() > 0) {
                txtNumber.setText(editData.getNumber());
            }
        }
    }

    /**
     * output loadFields method
     */
    public void loadFields()
    {
        		setAutoNumberByOrg("NONE");
        dataBinder.loadFields();
    }
		protected void setOrgF7(KDBizPromptBox f7,com.kingdee.eas.basedata.org.OrgType orgType) throws Exception
		{
			com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer oufip = new com.kingdee.eas.basedata.org.client.f7.NewOrgUnitFilterInfoProducer(orgType);
			oufip.getModel().setIsCUFilter(true);
			f7.setFilterInfoProducer(oufip);
		}

    /**
     * output storeFields method
     */
    public void storeFields()
    {
		dataBinder.storeFields();
    }

	/**
	 * ??????????
	 */
	protected void registerValidator() {
    	getValidateHelper().setCustomValidator( getValidator() );
		getValidateHelper().registerBindProperty("number", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("name", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("simpleName", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("description", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("person", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("personPosition", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("PersonDormitoryType", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("CheckInDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("CheckOutDate", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("Dormitory", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("Remarks", ValidateHelper.ON_SAVE);    
		getValidateHelper().registerBindProperty("state", ValidateHelper.ON_SAVE);    		
	}



    /**
     * output setOprtState method
     */
    public void setOprtState(String oprtType)
    {
        super.setOprtState(oprtType);
        if (STATUS_ADDNEW.equals(this.oprtState)) {
		            this.txtName.setEnabled(true);
		            this.txtDescription.setEnabled(true);
		            this.txtNumber.setEnabled(true);
		            this.txtSimpleName.setEnabled(true);
        } else if (STATUS_EDIT.equals(this.oprtState)) {
		            this.txtName.setEnabled(true);
		            this.txtDescription.setEnabled(true);
		            this.txtNumber.setEnabled(true);
		            this.txtSimpleName.setEnabled(true);
        } else if (STATUS_VIEW.equals(this.oprtState)) {
		            this.txtName.setEnabled(false);
		            this.txtDescription.setEnabled(false);
		            this.txtNumber.setEnabled(false);
		            this.txtSimpleName.setEnabled(false);
        }
    }

    /**
     * output getSelectors method
     */
    public SelectorItemCollection getSelectors()
    {
        SelectorItemCollection sic = new SelectorItemCollection();
		String selectorAll = System.getProperty("selector.all");
		if(StringUtils.isEmpty(selectorAll)){
			selectorAll = "true";
		}
        sic.add(new SelectorItemInfo("number"));
        sic.add(new SelectorItemInfo("name"));
        sic.add(new SelectorItemInfo("simpleName"));
        sic.add(new SelectorItemInfo("description"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("person.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("person.id"));
        	sic.add(new SelectorItemInfo("person.number"));
        	sic.add(new SelectorItemInfo("person.name"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("personPosition.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("personPosition.id"));
        	sic.add(new SelectorItemInfo("personPosition.joinDate"));
        	sic.add(new SelectorItemInfo("personPosition.number"));
		}
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("PersonDormitoryType.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("PersonDormitoryType.id"));
        	sic.add(new SelectorItemInfo("PersonDormitoryType.number"));
        	sic.add(new SelectorItemInfo("PersonDormitoryType.name"));
		}
        sic.add(new SelectorItemInfo("CheckInDate"));
        sic.add(new SelectorItemInfo("CheckOutDate"));
		if(selectorAll.equalsIgnoreCase("true"))
		{
			sic.add(new SelectorItemInfo("Dormitory.*"));
		}
		else{
        	sic.add(new SelectorItemInfo("Dormitory.id"));
        	sic.add(new SelectorItemInfo("Dormitory.number"));
        	sic.add(new SelectorItemInfo("Dormitory.name"));
        	sic.add(new SelectorItemInfo("Dormitory.RoomNumber"));
		}
        sic.add(new SelectorItemInfo("Remarks"));
        sic.add(new SelectorItemInfo("state"));
        return sic;
    }        

    /**
     * output getMetaDataPK method
     */
    public IMetaDataPK getMetaDataPK()
    {
        return new MetaDataPK("com.kingdee.eas.custom.dormitorysystem.occupants.client", "OccupantsEditUI");
    }

    /**
     * output getEditUIName method
     */
    protected String getEditUIName()
    {
        return com.kingdee.eas.custom.dormitorysystem.occupants.client.OccupantsEditUI.class.getName();
    }

    /**
     * output getBizInterface method
     */
    protected com.kingdee.eas.framework.ICoreBase getBizInterface() throws Exception
    {
        return com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory.getRemoteInstance();
    }

    /**
     * output createNewData method
     */
    protected IObjectValue createNewData()
    {
        com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo objectValue = new com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo();
        objectValue.setCreator((com.kingdee.eas.base.permission.UserInfo)(com.kingdee.eas.common.client.SysContext.getSysContext().getCurrentUser()));		
        return objectValue;
    }



    /**
     * output getDetailTable method
     */
    protected KDTable getDetailTable() {        
        return null;
	}
    /**
     * output applyDefaultValue method
     */
    protected void applyDefaultValue(IObjectValue vo) {        
		vo.put("state",new Integer(1));
        
    }        
	protected void setFieldsNull(com.kingdee.bos.dao.AbstractObjectValue arg0) {
		super.setFieldsNull(arg0);
		arg0.put("number",null);
	}

}