package com.kingdee.eas.custom.dormitorysystem.waterelectricity;

import java.io.Serializable;
import com.kingdee.bos.dao.AbstractObjectValue;
import java.util.Locale;
import com.kingdee.util.TypeConversionUtils;
import com.kingdee.bos.util.BOSObjectType;


public class AbstractWaterElectricityInfo extends com.kingdee.eas.hr.base.HRBillBaseInfo implements Serializable 
{
    public AbstractWaterElectricityInfo()
    {
        this("id");
    }
    protected AbstractWaterElectricityInfo(String pkField)
    {
        super(pkField);
        put("entrys", new com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityEntryCollection());
    }
    /**
     * Object: ˮϸ 's ¼ property 
     */
    public com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityEntryCollection getEntrys()
    {
        return (com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityEntryCollection)get("entrys");
    }
    /**
     * Object: ˮϸ 's  property 
     */
    public com.kingdee.eas.basedata.person.PersonInfo getApplier()
    {
        return (com.kingdee.eas.basedata.person.PersonInfo)get("applier");
    }
    public void setApplier(com.kingdee.eas.basedata.person.PersonInfo item)
    {
        put("applier", item);
    }
    /**
     * Object:ˮϸ's property 
     */
    public java.util.Date getApplyDate()
    {
        return getDate("applyDate");
    }
    public void setApplyDate(java.util.Date item)
    {
        setDate("applyDate", item);
    }
    /**
     * Object:ˮϸ's ״̬property 
     */
    public int getInnerState()
    {
        return getInt("innerState");
    }
    public void setInnerState(int item)
    {
        setInt("innerState", item);
    }
    /**
     * Object:ˮϸ's property 
     */
    public String getYearMonth()
    {
        return getString("yearMonth");
    }
    public void setYearMonth(String item)
    {
        setString("yearMonth", item);
    }
    /**
     * Object: ˮϸ 's Ա property 
     */
    public com.kingdee.eas.basedata.person.PersonInfo getPerson()
    {
        return (com.kingdee.eas.basedata.person.PersonInfo)get("person");
    }
    public void setPerson(com.kingdee.eas.basedata.person.PersonInfo item)
    {
        put("person", item);
    }
    /**
     * Object:ˮϸ's Աproperty 
     */
    public String getEmpName()
    {
        return getString("empName");
    }
    public void setEmpName(String item)
    {
        setString("empName", item);
    }
    /**
     * Object:ˮϸ's Աproperty 
     */
    public String getEmpNumber()
    {
        return getString("empNumber");
    }
    public void setEmpNumber(String item)
    {
        setString("empNumber", item);
    }
    /**
     * Object:ˮϸ's ְ״̬property 
     */
    public String getPositionStatus()
    {
        return getString("positionStatus");
    }
    public void setPositionStatus(String item)
    {
        setString("positionStatus", item);
    }
    /**
     * Object:ˮϸ's property 
     */
    public java.util.Date getLeaveDate()
    {
        return getDate("leaveDate");
    }
    public void setLeaveDate(java.util.Date item)
    {
        setDate("leaveDate", item);
    }
    /**
     * Object: ˮϸ 's  property 
     */
    public com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo getDormitory()
    {
        return (com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo)get("dormitory");
    }
    public void setDormitory(com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo item)
    {
        put("dormitory", item);
    }
    /**
     * Object:ˮϸ's ˮܷproperty 
     */
    public java.math.BigDecimal getWaterTotalCost()
    {
        return getBigDecimal("waterTotalCost");
    }
    public void setWaterTotalCost(java.math.BigDecimal item)
    {
        setBigDecimal("waterTotalCost", item);
    }
    /**
     * Object:ˮϸ's õܷproperty 
     */
    public java.math.BigDecimal getElectricityTotalCost()
    {
        return getBigDecimal("electricityTotalCost");
    }
    public void setElectricityTotalCost(java.math.BigDecimal item)
    {
        setBigDecimal("electricityTotalCost", item);
    }
    /**
     * Object:ˮϸ's ˮproperty 
     */
    public java.math.BigDecimal getMonthWaterAmount()
    {
        return getBigDecimal("monthWaterAmount");
    }
    public void setMonthWaterAmount(java.math.BigDecimal item)
    {
        setBigDecimal("monthWaterAmount", item);
    }
    /**
     * Object:ˮϸ's µproperty 
     */
    public java.math.BigDecimal getMonthElectricityAmount()
    {
        return getBigDecimal("monthElectricityAmount");
    }
    public void setMonthElectricityAmount(java.math.BigDecimal item)
    {
        setBigDecimal("monthElectricityAmount", item);
    }
    /**
     * Object:ˮϸ's סproperty 
     */
    public java.math.BigDecimal getMonthDays()
    {
        return getBigDecimal("monthDays");
    }
    public void setMonthDays(java.math.BigDecimal item)
    {
        setBigDecimal("monthDays", item);
    }
    /**
     * Object:ˮϸ's ״̬property 
     */
    public com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityStutas getStutas()
    {
        return com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityStutas.getEnum(getString("stutas"));
    }
    public void setStutas(com.kingdee.eas.custom.dormitorysystem.waterelectricity.WaterElectricityStutas item)
    {
		if (item != null) {
        setString("stutas", item.getValue());
		}
    }
    /**
     * Object:ˮϸ's property 
     */
    public String getMeterReading()
    {
        return getString("meterReading");
    }
    public void setMeterReading(String item)
    {
        setString("meterReading", item);
    }
    /**
     * Object:ˮϸ's ˮѱ׼property 
     */
    public String getHydropowerStandards()
    {
        return getString("hydropowerStandards");
    }
    public void setHydropowerStandards(String item)
    {
        setString("hydropowerStandards", item);
    }
    /**
     * Object: ˮϸ 's ְλ property 
     */
    public com.kingdee.eas.basedata.org.PositionInfo getPosition()
    {
        return (com.kingdee.eas.basedata.org.PositionInfo)get("position");
    }
    public void setPosition(com.kingdee.eas.basedata.org.PositionInfo item)
    {
        put("position", item);
    }
    /**
     * Object:ˮϸ's ʼproperty 
     */
    public java.util.Date getStartDate()
    {
        return getDate("startDate");
    }
    public void setStartDate(java.util.Date item)
    {
        setDate("startDate", item);
    }
    /**
     * Object:ˮϸ's property 
     */
    public java.util.Date getEndDate()
    {
        return getDate("endDate");
    }
    public void setEndDate(java.util.Date item)
    {
        setDate("endDate", item);
    }
    /**
     * Object:ˮϸ's Աסproperty 
     */
    public java.math.BigDecimal getAllMonthDays()
    {
        return getBigDecimal("allMonthDays");
    }
    public void setAllMonthDays(java.math.BigDecimal item)
    {
        setBigDecimal("allMonthDays", item);
    }
    public BOSObjectType getBOSType()
    {
        return new BOSObjectType("9D5F2CA3");
    }
}